#include "testApp.h"

//--------------------------------------------------------------
void testApp::setup(){
	helsinki.loadImage("images/Helsinki.jpg");
	helsinki.setImageType(OF_IMAGE_GRAYSCALE);
	zoomValue =8;
}

//--------------------------------------------------------------
void testApp::update(){

}

//--------------------------------------------------------------
void testApp::draw(){
	//helsinki.draw(0,0);
	unsigned char *pixels = helsinki.getPixels();
	//w and h are the width and height of my selected area within the image
	//for the whole image, it would be helsinki.width and helsinki.heigh
	int w = 130;
	int h = 140;
	int startX = 220;
	int startY = 20;
	//i is the x starting point of my selection within the image
	//j is the y starting point of my selection within the image
	//to select the whole image, set i and j to 0
	for (int i=startX; i<w+startX; i++) {
		for (int j=startY; j<h+startY; j++){
			int pixelValue = pixels[i+j*helsinki.width];
			ofSetColor(0, 0, 255);
			//to force into float, use .0f with an integer or (float)
			//ex: pixelValue/255.0f
			//or: (float)pixelValue/255
			float percent = 1-(pixelValue/255.0f);
			//for negative images, use
			//float percent = pixelValue/255.0f;
			ofCircle(i*(zoomValue)-startX*zoomValue,j*(zoomValue)
					 -startY*zoomValue,percent*zoomValue);
		}
	}
	ofSetColor(255,255,255);
	ofRect(0,0,ofGetWidth(),15);
	ofSetColor(0,0,0);
	ofDrawBitmapString("Press up and down arrow keys to zoom. Zoom:"+ofToString(zoomValue),
					   10, 12);
	
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){
	if (key == 'p') {
		string dateStamp = "_"+ofToString(ofGetYear())+"-"+ofToString(ofGetMonth())+"-"+ofToString(ofGetDay())+"_"+ofToString(ofGetHours())+"-"+ofToString(ofGetMinutes())+"_"+ofToString(ofGetSeconds());
		ofSaveScreen("screenshot"+dateStamp+".png");
	}		
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){
	if(key==OF_KEY_DOWN){
		if(zoomValue>2){
		zoomValue--;
		}
	}
	if(key==OF_KEY_UP){
		zoomValue++;
	}
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

